//
//  MediaLoader.m
//  FM10SX
//
//  Created by Amy Kettlewell on 09/10/31.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "MediaLoader.h"
#import "MediaClubLoader.h"
#import "FMString.h"
#import "FMDateLoader.h"

@implementation Loader (MediaLoader)

+ (Media *)readMediaFromData:(NSData *)data atOffset:(unsigned int *)byteOffset
{
	char cbuffer;
	int ibuffer, count;
    BOOL debug = NO;
	
	unsigned int offset = *byteOffset;
	
	Media *object = [[Media alloc] init];
	
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setDatabaseClass:cbuffer];
	[object setName:[FMString readFromData:data atOffset:&offset]];
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setNameGender:cbuffer];
	
	[data getBytes:&count range:NSMakeRange(offset, 4)]; offset += 4;
	NSMutableArray *tempArray = [[NSMutableArray alloc] init];
	for (int i=0;i<count;i++) {
		[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
		[tempArray addObject:[NSNumber numberWithChar:cbuffer]];
	}
	[object setTypes:tempArray];
	[tempArray release];
	
	[object setURL:[FMString readFromData:data atOffset:&offset]];
	
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setFake:cbuffer];
	
	[data getBytes:&count range:NSMakeRange(offset, 4)]; offset += 4;
	tempArray = [[NSMutableArray alloc] init];
	for (int i=0;i<count;i++) {
		[data getBytes:&ibuffer range:NSMakeRange(offset, 4)]; offset += 4;
		[tempArray addObject:[NSNumber numberWithInt:ibuffer]];
	}
	[object setCompetitions:tempArray];
	[tempArray release];
	
	[data getBytes:&ibuffer range:NSMakeRange(offset, 4)]; offset += 4;
	[object setCityID:ibuffer];
	[data getBytes:&ibuffer range:NSMakeRange(offset, 4)]; offset += 4;
	[object setLocalAreaID:ibuffer];
	
	[data getBytes:&count range:NSMakeRange(offset, 4)]; offset += 4;
	tempArray = [[NSMutableArray alloc] init];
	for (int i=0;i<count;i++) {
		[data getBytes:&ibuffer range:NSMakeRange(offset, 4)]; offset += 4;
		[tempArray addObject:[NSNumber numberWithInt:ibuffer]];
	}
	[object setNations:tempArray];
	[tempArray release];
	
	[data getBytes:&ibuffer range:NSMakeRange(offset, 4)]; offset += 4;
	[object setContinentID:ibuffer];
	
	[data getBytes:&ibuffer range:NSMakeRange(offset, 4)]; offset += 4;
	tempArray = [[NSMutableArray alloc] init];
	for (int i=0;i<ibuffer;i++) {
		[tempArray addObject:[MediaClubLoader readFromData:data atOffset:&offset]];
	}
	[object setClubs:tempArray];
	[tempArray release];
    
    // FM 2012 
	
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setPeriod:cbuffer];
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setScope:cbuffer];
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setStyle:cbuffer];
	[object setLastPublishedDate:[FMDateLoader readFromData:data atOffset:&offset]];
	
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	tempArray = [[NSMutableArray alloc] init];
	for (int i=0;i<cbuffer;i++) {
		[data getBytes:&ibuffer range:NSMakeRange(offset, 4)]; offset += 4;
		[tempArray addObject:[NSNumber numberWithInt:ibuffer]];
	}
	[object setJournalists:tempArray];
	[tempArray release];
	
	[data getBytes:&count range:NSMakeRange(offset, 4)]; offset += 4;
	tempArray = [[NSMutableArray alloc] init];
	for (int i=0;i<count;i++) {
		[data getBytes:&ibuffer range:NSMakeRange(offset, 4)]; offset += 4;
		[tempArray addObject:[NSNumber numberWithInt:ibuffer]];
	}
	[object setLinkedMedia:tempArray];
	[tempArray release];
	
	[data getBytes:&ibuffer range:NSMakeRange(offset, 4)]; offset += 4;
	[object setRowID:ibuffer];
	[data getBytes:&ibuffer range:NSMakeRange(offset, 4)]; offset += 8; //FM 2012 Double ID
	[object setUID:ibuffer];
	
    if (debug) { NSLog(@"Media %d (%@) at %d",[object rowID],[object name],offset); }
    
	*byteOffset = offset;
	
	return object;
}

@end
