//
//  PlayerStatsLoader.m
//  FM10SX
//
//  Created by Amy Kettlewell on 09/11/04.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "PlayerStatsLoader.h"

@implementation Loader (PlayerStatsLoader)

+ (PlayerStats *)readPlayerStatsFromData:(NSData *)data atOffset:(unsigned int *)byteOffset
{
	char cbuffer;
	int ibuffer;
	
	unsigned int offset = *byteOffset;
	
	PlayerStats *object = [[PlayerStats alloc] init];
    
    // Stats need debugging, temporarily removed extra bytes
	
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setDatabaseClass:cbuffer];
    
    // Positions (???)
    [data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setGoalkeeper:cbuffer];
    [data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setSweeper:cbuffer];
    [data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setLeftDefender:cbuffer];
    [data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setCentralDefender:cbuffer];
    [data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setRightDefender:cbuffer];
    [data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setCentralDefensiveMidfielder:cbuffer];
    [data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setLeftMidfielder:cbuffer];
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
    [object setCentralMidfielder:cbuffer];
    [data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setRightMidfielder:cbuffer];
    [data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setLeftAttackingMidfielder:cbuffer];
    [data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setCentralAttackingMidfielder:cbuffer];
    [data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setRightAttackingMidfielder:cbuffer];
    [data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setCentreForward:cbuffer];
    [data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setLeftWingBack:cbuffer];
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setRightWingBack:cbuffer];
    
    [data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setCrossing:cbuffer];
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setDribbling:cbuffer];
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setFinishing:cbuffer];
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setHeading:cbuffer];
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setLongShots:cbuffer];
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setMarking:cbuffer];
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setOffTheBall:cbuffer];
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setPassing:cbuffer];
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setPenalties:cbuffer];
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setTackling:cbuffer];
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setCreativity:cbuffer];
	
    [data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setHandling:cbuffer];
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setAerialAbility:cbuffer];
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setCommandOfArea:cbuffer];
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setCommunication:cbuffer];
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setKicking:cbuffer];
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setThrowing:cbuffer];
	
	// [data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	// [object setUnknownChar1:cbuffer];
	
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setAnticipation:cbuffer];
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setDecisions:cbuffer];
	
    [data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setOneOnOnes:cbuffer];
	
    [data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setPositioning:cbuffer];
	
    [data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setReflexes:cbuffer];
    
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setFirstTouch:cbuffer];
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setTechnique:cbuffer];
	
    [data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setLeftFoot:cbuffer];
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setRightFoot:cbuffer];
	
    [data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setFlair:cbuffer];
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setCorners:cbuffer];
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setTeamwork:cbuffer];
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setWorkRate:cbuffer];
    [data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setLongThrows:cbuffer];
    
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setEccentricity:cbuffer];
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setRushingOut:cbuffer];
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setTendencyToPunch:cbuffer];
    
    
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setAcceleration:cbuffer];
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setFreeKicks:cbuffer];
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setStrength:cbuffer];
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setStamina:cbuffer];
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setPace:cbuffer];
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setJumping:cbuffer];
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setInfluence:cbuffer];
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setDirtiness:cbuffer];
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setBalance:cbuffer];
    [data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setBravery:cbuffer];
    
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setConsistency:cbuffer];
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setAggression:cbuffer];
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setAgility:cbuffer];
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setImportantMatches:cbuffer];
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setInjuryProneness:cbuffer];
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setVersatility:cbuffer];
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setNaturalFitness:cbuffer];
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setDetermination:cbuffer];
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setComposure:cbuffer];
	[data getBytes:&cbuffer range:NSMakeRange(offset, 1)]; offset += 1;
	[object setConcentration:cbuffer];
     
	[data getBytes:&ibuffer range:NSMakeRange(offset, 4)]; offset += 4;
	[object setRowID:ibuffer];
	[data getBytes:&ibuffer range:NSMakeRange(offset, 4)]; offset += 8; // FM 2012 Double ID
	[object setUID:ibuffer];
	
	*byteOffset = offset;
	
	return object;
}

@end
